require "scripts.tools"

local turretMods = require "prototypes.turrets"

data.raw["electric-turret"]["laser-turret"].fast_replaceable_group = "laser-turret"
data.raw["ammo-turret"]["gun-turret"].fast_replaceable_group = "gun-turret"

function updateGunTurretUpgrades(gunTurretMod)
	local techNamePrefix = "gun-turret-damage-"
	
	for techIndex = 1, 6 do
		local techName = techNamePrefix .. techIndex
		local techEffects = data.raw.technology[techName].effects
		local baseTechEffect = techEffects[1]
		
		for turretLevel = 1, gunTurretMod.levelCount do
			local effectCopy = table.deepcopy(baseTechEffect)
			
			effectCopy.turret_id = createObjectName(gunTurretMod.objectName, turretLevel)
			
			techEffects[#techEffects + 1] = effectCopy
		end
	end
end

for _, turretMod in pairs(turretMods) do
	if turretMod.typeName == "ammo-turret" then
		updateGunTurretUpgrades(turretMod)
	end
end
