local baseGateResistances =
{
  {
	type = "physical",
	decrease = 5,
	percent = 50
  },
  {
	type = "impact",
	decrease = 45,
	percent = 60
  },
  {
	type = "explosion",
	decrease = 10,
	percent = 50
  },
  {
	type = "fire",
	percent = 100
  },
  {
	type = "laser",
	percent = 70
  },
  {
	type = "poison",
	decrease = 5,
	percent = 50
  },
  {
	type = "acid",
	decrease = 5,
	percent = 50
  }  
}
	
local function wallLevel(level)
	return level
end

local function plateCost(level)
	return 4
end

local function circuitCost(level)
	return 4
end

local function alwaysOne(level)
	return 1
end

local function researchTime(level)
	return 30 + 10 * math.floor(level / 2)
end

local function researchAmount(level)
	return 30 * ((level + 1) % 2 + 1)
end

local function packAmount(level)
	return 1-- + math.floor(level / 2)
end

local gateMod =
{
	typeName = "gate",
	baseName = "gate",
	objectName = "fort-gate",
	objectMod =
	{
		healthFn = function(level) return 1000 end,
		baseResists = baseGateResistances,
		decreaseResFn = function(level) return 0 end,
		percentResFn = function(level) return 0 end,
	},
	itemMod =
	{
		subgroup = "reinforcedGates"
	},
	recipeMod =
	{
--		usePreviousItem = true,
--		previousCountFn = returnOne,
		useItem = true,
		useItemName = "fort-wall",
		useItemLevelFn = wallLevel,
		useItemCountFn = alwaysOne,
		ingredients =
		{
			{ "steel-plate", plateCost },
			{ "electronic-circuit", circuitCost },
		}
	},
	techMod =
	{
		baseTech = "gates",
		techName = "fort-gates",
		order = "a-l-a-a",
		
		countFn = function(level) return 100 end,
		timeFn = function(level) return 40 end,
		
		ingredients =
		{
			{"science-pack-1", packAmount},
			{"science-pack-2", packAmount},
--			{"science-pack-3", packAmount, minLevel = 3},
--			{"alien-science-pack", packAmount, minLevel = 5},
		}
	},
	levelCount = 1,
}

return { gateMod }