local baseTurretResistances =
{
  {
	type = "physical",
	percent = 20
  },
  {
	type = "impact",
	decrease = 20,
	percent = 35
  },
  {
	type = "explosion",
	percent = 20
  },
  {
	type = "fire",
	percent = 20
  },
  {
	type = "laser",
	percent = 20
  },
  {
	type = "poison",
	percent = 20
  },
  {
	type = "acid",
	percent = 20
  }
}

local function packAmount(level)
	return 1-- + math.floor(level / 2)
end


local heavyGunTurretMod =
{
	typeName = "ammo-turret",
	baseName = "gun-turret",
	objectName = "fort-heavy-gun-turret",
	iconName = "heavy-gun-turret",
	
	objectMod =
	{
		healthFn = function(level) return 200 + 200 * level end,
		rangeFn = function(level) return -2 end,
		damageModFn = function(level) return 1 + 0.1 * level end,
		baseResists = baseTurretResistances,
		decreaseResFn = function(level) return level * 2 end,
		percentResFn = function(level) return level * 10 end,
		fastReplaceGroup = "gun-turret"
	},
	itemMod =
	{
		subgroup = "heavyGunTurrets"
	},
	recipeMod =
	{
		energyRequiredFn = function(level) return 10 end,
		ingredients =
		{
			{ "iron-gear-wheel", function(level) return 10 end },
			{ "copper-plate", function(level) return 10 end, maxLevel = 1 },
			{ "iron-plate", function(level) return level * 10 end, maxLevel = 2 },
			{ "steel-plate", function(level) return level * 10 end, minLevel = 2 },
		}
	},
	techMod =
	{
		baseTech = "turrets",
		techName = "fort-heavy-gun-turrets",
		order = "a-j-a-a",
		
		countFn = function(level) return 50 * level end,
		timeFn = function(level) return 40 + level * 20 end,
		
		ingredients =
		{
			{"science-pack-1", packAmount},
			{"science-pack-2", packAmount, minLevel = 2},
			{"science-pack-3", packAmount, minLevel = 3} 
		}
	},
	levelCount = 3,
}


local longGunTurretMod =
{
	typeName = "ammo-turret",
	baseName = "gun-turret",
	objectName = "fort-long-gun-turret",
	iconName = "long-gun-turret",
	
	objectMod =
	{
		healthFn = function(level) return 300 end,
		rangeFn = function(level) return 3 + math.floor(level * 3.35) end,
		damageModFn = function(level) return 0.8 end,
		baseResists = baseTurretResistances,
		decreaseResFn = function(level) return 0 end,
		percentResFn = function(level) return 0 end,
		fastReplaceGroup = "gun-turret"
	},
	itemMod =
	{
		subgroup = "longGunTurrets"
	},
	recipeMod =
	{
		energyRequiredFn = function(level) return 10 end,
		ingredients =
		{
			{ "iron-gear-wheel", function(level) return 5 + 5 * level end },
			{ "copper-plate", function(level) return 5 end },
			{ "iron-plate", function(level) return 5 + 5 * level end },
--			{ "steel-plate", function(level) return level * 10 end, minLevel = 2 },
		}
	},
	techMod =
	{
		baseTech = "turrets",
		techName = "fort-long-gun-turrets",
		order = "a-j-b-a",
		
		countFn = function(level) return 50 * level end,
		timeFn = function(level) return 40 + level * 20 end,
		
		ingredients =
		{
			{"science-pack-1", packAmount},
			{"science-pack-2", packAmount, minLevel = 2},
			{"science-pack-3", packAmount, minLevel = 3} 
		}
	},
	levelCount = 3,
}


local heavyLaserTurretMod =
{
	typeName = "electric-turret",
	baseName = "laser-turret",
	objectName = "fort-heavy-laser-turret",
	iconName = "heavy-laser-turret",
	
	objectMod =
	{
		healthFn = function(level) return 200 + 200 * level end,
		rangeFn = function(level) return -5 end,
		damageModFn = function(level) return 1 + 0.1 * level end,
		baseResists = baseTurretResistances,
		decreaseResFn = function(level) return level * 2 end,
		percentResFn = function(level) return level * 10 end,
		fastReplaceGroup = "laser-turret",
	},
	itemMod =
	{
		subgroup = "heavyLaserTurrets"
	},
	recipeMod =
	{
		energyRequiredFn = function(level) return 10 end,
		ingredients =
		{
			{ "steel-plate", function(level) return 5 + 5 * level end },
			{ "electronic-circuit", function(level) return 5 end },
			{ "battery", function(level) return 3 end },
		}
	},
	techMod =
	{
		baseTech = "laser-turrets",
		techName = "fort-heavy-laser-turrets",
		order = "a-j-c-a",
		
		countFn = function(level) return 50 + 50 * level end,
		timeFn = function(level) return 40 + level * 20 end,
		
		ingredients =
		{
			{"science-pack-1", packAmount},
			{"science-pack-2", packAmount},
			{"science-pack-3", packAmount, minLevel = 2},
			{"alien-science-pack", packAmount, minLevel = 3},
		}
	},
	levelCount = 3,
}


local longLaserTurretMod =
{
	typeName = "electric-turret",
	baseName = "laser-turret",
	objectName = "fort-long-laser-turret",
	iconName = "long-laser-turret",
	
	objectMod =
	{
		healthFn = function(level) return 350 end,
		rangeFn = function(level) return 5 * level end,
		damageModFn = function(level) return 0.8 end,
		baseResists = baseTurretResistances,
		decreaseResFn = function(level) return 0 end,
		percentResFn = function(level) return 0 end,
		fastReplaceGroup = "laser-turret",
	},
	itemMod =
	{
		subgroup = "longLaserTurrets"
	},
	recipeMod =
	{
		energyRequiredFn = function(level) return 10 end,
		ingredients =
		{
			{ "steel-plate", function(level) return 5 end },
			{ "electronic-circuit", function(level) return 4 + level * 2 end },
			{ "battery", function(level) return 3 + level * 3 end },
		}
	},
	techMod =
	{
		baseTech = "laser-turrets",
		techName = "fort-long-laser-turrets",
		order = "a-j-d-a",
		
		countFn = function(level) return 50 + 50 * level end,
		timeFn = function(level) return 40 + level * 20 end,
		
		ingredients =
		{
			{"science-pack-1", packAmount},
			{"science-pack-2", packAmount},
			{"science-pack-3", packAmount, minLevel = 2},
			{"alien-science-pack", packAmount, minLevel = 3},
		}
	},
	levelCount = 3,
}

return { heavyGunTurretMod, longGunTurretMod, heavyLaserTurretMod, longLaserTurretMod }