local baseWallResistances =
{
  {
	type = "physical",
	decrease = 5,
	percent = 50
  },
  {
	type = "impact",
	decrease = 45,
	percent = 60
  },
  {
	type = "explosion",
	decrease = 10,
	percent = 50
  },
  {
	type = "fire",
	percent = 100
  },
  {
	type = "laser",
	percent = 70
  },
  {
	type = "poison",
	decrease = 5,
	percent = 50
  },
  {
	type = "acid",
	decrease = 5,
	percent = 50
  }  
}
	
local function returnOne(level)
	return 1
end

local function energyRequired(level)
	return 1 + level / 2
end

local function brickCost(level)
	return 10
end

local function plateCost(level)
	return 2
end

local function researchTime(level)
	return 30 + 10 * math.floor(level / 2)
end

local function researchAmount(level)
	return 30 * ((level + 1) % 2 + 1)
end

local function packAmount(level)
	return 1-- + math.floor(level / 2)
end

local wallMod =
{
	typeName = "wall",
	baseName = "stone-wall",
	objectName = "fort-wall",
	iconName = "fort-wall",
	
	objectMod =
	{
		healthFn = function(level) return 1000 end,
		baseResists = baseWallResistances,
		decreaseResFn = function(level) return 0 end,
		percentResFn = function(level) return 0 end,
	},
	itemMod =
	{
		subgroup = "reinforcedWalls"
	},
	recipeMod =
	{
--		usePreviousItem = true,
--		previousCountFn = returnOne,
		energyRequiredFn = energyRequired,
		ingredients =
		{
			{ "stone-brick", brickCost },
			{ "copper-plate", plateCost, maxLevel = 2 },
			{ "iron-plate", plateCost, minLevel = 3, maxLevel = 4 },
			{ "steel-plate", plateCost, minLevel = 5 },
		}
	},
	techMod =
	{
		baseTech = "stone-walls",
		techName = "fort-walls",
		order = "a-k-a-a",
		
		countFn = function(level) return 100 end,
		timeFn = function(level) return 30 end,
		
		ingredients =
		{
			{"science-pack-1", packAmount},
--			{"science-pack-2", packAmount, minLevel = 3},
--			{"science-pack-3", packAmount, minLevel = 5} 
		}
	},
	levelCount = 1,
}

return { wallMod }